<?php

class EWRporta_Block_BuycraftDonateDisplay extends XenForo_Model
{
  public function getModule(&$options)
  {
    try {
      $bcInstance = new EWRporta_Block_BuycraftDonateDisplay_phpBuycraftAPI($options['secretApiKey']);
      $currency = $bcInstance->getServerCurrency();
      $options['currency'] = $currency;
      if ($options['start'] === 2) {
        $date = time() - (30 * 24 * 60 * 60);
        $options['startString'] = "past 30 days";
      } else {
        $date = mktime(0, 0, 0, date("n"), 1);
        $options['startString'] = "starting ".date("F")." 1st";
      }
      $paymentListRaw = $bcInstance->getPaymentsSince($date);
      $amount = 0;
      foreach($paymentListRaw as $value) {
        if ($bcInstance->getPaymentCurrency($value) === $currency) {
          $amount += $bcInstance->getPaymentPrice($value);
        }
      }
      $options['amount'] = $amount;
      $goal = $options['goal'];
      if ($goal == 0) {
        $options['percent'] = 100;
      } else {
        $options['percent'] = round($amount / $goal * 100);
      }
    } catch (RuntimeException $e) {
      $options['display'] = FALSE;
      return;
    }
    $options['display'] = TRUE;
    return;
  }

  public static function callbackSecretApiKey(&$value, $dw, $fieldName) {
    if ((strlen($value) == 0) || (ctype_xdigit($value) === TRUE && strlen($value) == 40)) {
      return true;
    } else {
      return false;
    }
  }
}
